#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <inttypes.h>
#include <string.h>
#include <math.h>
int set_ROI(double theta, double z);
void read_event();
void init_rom();
void r_cal();
void dual_slice();
void dual_slice2();
void slice_RAM(int theta_bin,int we_RAM[2], int ae, int ao);
void new_hit(double a, double b, double c);
void get_spm();
void get_spm2();
char *s;
int print_HITs, event_no, evn;
char histo[128][256], OOR[2][33];
//input unit: R_theta_in in radian, all others in mm
int n_hit = 6;
double ROI_theta_in = 1.328;
double ROI_z0_in = 210.0;
double z0_in[6] = {198.499,213.516,228.534,318.639,303.621,318.639};
double y0_in[6] = {14.997,41.008,67.019,414.057,440.068,466.079};
double R_drift_in[6] = {12.703140,4.05652,4.762524,10.277486,6.523302,2.242458};
int R_drift,ROI_theta;
double seg_z0;
uint32_t csc[2048];
int32_t sine[17][1024],cosine[17][1024], counter[6], diff,cycles=0, max[128], seg_theta, seg_oc;
int32_t ROI_z0,z0,y,r_plusR[2][33],r_minusR[2][33];
int main(int argc, char *argv[])
{
  int i, j;
  //  long int theta_in;
  // load rom table from coe files
  s = "n";
  print_HITs = 0;
  evn = -1;
  if(argc >= 2)
    s = argv[1];
  if(argc >= 3)
    print_HITs = atoi(argv[2]);
  if(argc == 4)
    evn = atoi(argv[3]);
  init_rom();
  read_event();
  //  if(set_ROI(ROI_theta_in,ROI_z0_in))
  //    exit(1);
  //for each hit call new_hit once until exausted
  //  for(i = 0; i < n_hit; i++)
  //    new_hit(z0_in[i], y0_in[i], R_drift_in[i]);
  //  get_spm();
  exit(0);
}

void read_event()
{
  FILE *f, *fout;
  int hitn;
  char line[100];
  double a,b,c;
  event_no = 0;
  f = fopen("firmware_valid.txt","r");
  fout = fopen("sim_out.txt","w");
  hitn = 0;
  // loop over record in the file and read them in the array "line"
  while ( fgets(line, 100, f) != NULL) {
    if(strncmp(line,"ROI:",4) == 0){
      sscanf(line+5,"%lf%lf",&a,&b);
      if(set_ROI(a,b))
	exit(1);
      fprintf(fout,"    if(evn_cnt = %d)then\n",event_no);
      fprintf(fout,"      ROI_theta_in <= x\"%03x\";\n      ROI_z0 <= x\"%04x\";\n",ROI_theta,ROI_z0/128);
    }
    if(strncmp(line,"SEG:",4) == 0 || strncmp(line,"MUSEG:",6) == 0 || strncmp(line,"ROI:",4) == 0)
      printf("%s",line);
    if(print_HITs == 1 && strncmp(line,"HIT:",4) == 0)
      printf("%s",line);
    if(strncmp(line,"HIT:",4) == 0){
      sscanf(line+5,"%lf%lf%lf",&a,&b,&c);
      fprintf(fout,"      hit_z0(%d) <= x\"%06x\";\n", hitn, (unsigned int) (128.0*a+0.5));
      fprintf(fout,"      hit_y0(%d) <= x\"%05x\";\n", hitn, (unsigned int) (128.0*b+0.5));
      fprintf(fout,"      hit_R_drift(%d) <= x\"%03x\";\n", hitn, (unsigned int) (64.0*c+0.5));
      new_hit(a,b,c);
      hitn++;
    }
    if(strncmp(line,"END HITS",8) == 0){
      fprintf(fout,"      N_hit <= %d;\n", hitn);
      fprintf(fout,"    end if;\n");
      hitn = 0;
      if(strcmp(s,"s1") == 0 || strcmp(s,"n1") == 0){
	//	printf("call get_spm\n");
	get_spm();
      }
      else{
	//	printf("call get_spm2\n");
	get_spm2();
      }
      event_no++;
    }
  }
  fclose(f);
  fclose(fout);
  return;
}

int set_ROI(double theta, double z)
{
  int i,j;
  if(theta > 2.047 || theta < 0.256){
    printf("ROI_theta %f out of range\n",theta);
    return(1);
  }
  ROI_theta = theta*500;
  ROI_theta *= 2;
  ROI_z0 = z;
  ROI_z0 *= 128;
  // reset histogram before a new event
  for(i = 0; i < 128; i++){
    max[i] = 0;
    for(j = 0; j < 256; j++)
      histo[i][j] = 0;
  }
  return(0);
}

void get_spm(){
  int i, j, theta_bin, r_bin;
  long int maxa[64], maxb[32], maxc[16], maxd[8],maxe[4],maxf[2];
  if(event_no < evn)
    for(i=28;i<40;i++)
      printf("max[%d] = %x max[%d] = %x\n",2*i,max[2*i],2*i+1, max[2*i+1]);
  for(i=0;i<64;i++)
    if((0xf & max[2*i+1]) > (0xf & max[2*i]))
      maxa[i] = 0x1000 | max[2*i+1];
    else
      maxa[i] = max[2*i];
  for(i=0;i<32;i++)
    if((0xf & maxa[2*i+1]) > (0xf & maxa[2*i]))
      maxb[i] = 0x2000 | maxa[2*i+1];
    else
      maxb[i] = maxa[2*i];
  for(i=0;i<16;i++)
    if((0xf & maxb[2*i+1]) > (0xf & maxb[2*i]))
      maxc[i] = 0x4000 | maxb[2*i+1];
    else
      maxc[i] = maxb[2*i];
  for(i=0;i<8;i++)
    if((0xf & maxc[2*i+1]) > (0xf & maxc[2*i]))
      maxd[i] = 0x8000 | maxc[2*i+1];
    else
      maxd[i] = maxc[2*i];
  for(i=0;i<4;i++)
    if((0xf & maxd[2*i+1]) > (0xf & maxd[2*i]))
      maxe[i] = 0x10000 | maxd[2*i+1];
    else
      maxe[i] = maxd[2*i];
  for(i=0;i<2;i++)
    if((0xf & maxe[2*i+1]) > (0xf & maxe[2*i]))
      maxf[i] = 0x20000 | maxe[2*i+1];
    else
      maxf[i] = maxe[2*i];
  if((0xf & maxf[1]) > (0xf & maxf[0])){
    seg_oc = 0xf & maxf[1];
    seg_theta = ROI_theta + ((0x3f000 & maxf[1]) >> 12);// unit is milli-radian
    seg_z0 = (((0xff0 & maxf[1]) >> 4) - 128)*csc[seg_theta];
    seg_z0 = seg_z0/131072.0+ROI_z0/128;// unit is 1.0mm
    theta_bin = 0x40+((0x3f000 & maxf[1]) >> 12);
    r_bin = (0xff0 & maxf[1]) >> 4;
    printf("theta_bin = 0x%x r_bin = 0x%x n = %d\n",theta_bin,r_bin, seg_oc);
    printf("seg_theta = %1.3f seg_z0 = %.3f\n", seg_theta/1000.0, seg_z0);
    printf("\n");
  }
  else{
    seg_oc = 0xf & maxf[0];
    seg_theta = ROI_theta - 64 + ((0x3f000 & maxf[0]) >> 12);// unit is milli-radian
    seg_z0 = (((0xff0 & maxf[0]) >> 4) - 128)*csc[seg_theta];
    seg_z0 = seg_z0/131072.0+ROI_z0/128;// unit is 1.0mm
    theta_bin = (0x3f000 & maxf[0]) >> 12;
    r_bin = (0xff0 & maxf[0]) >> 4;
    printf("theta_bin = 0x%x r_bin = 0x%x n = %d\n",theta_bin,r_bin, seg_oc);
    printf("seg_theta = %1.3f seg_z0 = %.3f\n", seg_theta/1000.0, seg_z0);
    printf("\n");
  }
  if(seg_oc < 4)
    printf("no segment found\n");
  /*  else
      printf("seg parameter => maxn = %d seg_z = %lf(mm) theta = %d(mR)\n", seg_oc, seg_z0, seg_theta);*/
  for(i=theta_bin-3;i< theta_bin+3;i++)
    for(j=r_bin-2;j<r_bin+2;j++)
      printf("theta = %02x r = %02x n = %d\n",i,j,histo[i][j]);
  return;
}
void get_spm2(){
  int i, j, r[130], n[130],r_ok[10],max_sum[8],max_sum3[8],theta_bin, r_bin;
  int muxa[4],muxb[2],muxc,max_oc;
  r[0] = 0;
  r[129] = 0;
  n[0] = 0;
  n[129] = 0;
  for(i=1;i<129;i++){
    r[i] = (max[i-1] & 0xff0) >> 4;
    n[i] = max[i-1] & 0xf;
  }
  max_oc = 0;
  for(i=0;i<16;i++){
    for(j=0;j<10;j++)
      if(abs(r[8*i+j+1] - r[8*i+j]) > 2)
	r_ok[j] = 0;
      else
	r_ok[j] = 1;
    for(j=0;j<4;j++)
      if(r_ok[j*2+1] == 0){
	max_sum[j*2] = n[8*i+j*2+1];
	max_sum[j*2+1] = n[8*i+j*2+2];
      }
      else{
	max_sum[j*2] = n[8*i+j*2+1] + n[8*i+j*2+2];
	max_sum[j*2+1] = n[8*i+j*2+1] + n[8*i+j*2+2];
      }
    for(j=0;j<4;j++){
      if(n[8*i+j*2+1] < 3)
	max_sum3[j*2] = 0;
      else if(r_ok[j*2] == 0)
	max_sum3[j*2] = max_sum[j*2];
      else
	max_sum3[j*2] = max_sum[j*2] + n[8*i+j*2];
      if(n[8*i+j*2+2] < 3)
	max_sum3[j*2+1] = 0;
      else if(r_ok[j*2+2] == 0)
	max_sum3[j*2+1] = max_sum[j*2+1];
      else
	max_sum3[j*2+1] = max_sum[j*2+1] + n[8*i+j*2+3];
    }
    for(j=0;j<4;j++)
      if(max_sum3[j*2] > max_sum3[j*2+1])
	muxa[j] = max_sum3[j*2];
      else
	muxa[j] = 0x40 + max_sum3[j*2+1];
    if((muxa[0] & 0x3f) > (muxa[1] & 0x3f))
      muxb[0] = muxa[0];
    else
      muxb[0] = 0x80 + muxa[1];
    if((muxa[2] & 0x3f) > (muxa[3] & 0x3f))
      muxb[1] = muxa[2];
    else
      muxb[1] = 0x80 + muxa[3];
    if((muxb[0] & 0x3f) > (muxb[1] & 0x3f))
      muxc = muxb[0];
    else
      muxc = 0x100 + muxb[1];
    if((muxc & 0x3f) > max_oc){
      max_oc = muxc & 0x3f;
      theta_bin = i*8 + ((muxc & 0x1c0) >> 6);
      r_bin = r[i*8+((muxc & 0x1c0) >> 6)+1];
    }
  }
  seg_theta = ROI_theta + theta_bin - 64;
  seg_oc = n[theta_bin+1];
  seg_z0 = (r_bin-128.0)*csc[seg_theta]/131072.0 + ROI_z0/128.0;
  if(seg_oc < 4)
    printf("no segment found\n");
  else{
    printf("theta_bin = 0x%x r_bin = 0x%x n = %d\n",theta_bin,r_bin, seg_oc);
    printf("seg_theta = %1.3f seg_z0 = %.3f\n", seg_theta/1000.0, seg_z0);
    printf("\n");
  }
  /*  for(i=theta_bin-5;i< theta_bin+5;i++)
    for(j=r_bin-2;j<r_bin+2;j++)
    printf("theta = %02x r = %02x n = %d\n",i,j,histo[i][j]);*/
  return;
}

void slice_RAM(int theta_bin,int we_RAM[2], int ae, int ao)
{
  if(we_RAM[0] == 1)
    if(histo[theta_bin][ae << 1]++ == (max[theta_bin] & 0xf) && ((max[theta_bin] & 0xf) != 0xf))
      max[theta_bin] = ae << 5 | ((max[theta_bin] & 0xf) + 1);
  if(we_RAM[1] == 1)
    if(histo[theta_bin][(ao << 1) + 1]++ == (max[theta_bin] & 0xf) && ((max[theta_bin] & 0xf) != 0xf))
      max[theta_bin] = ao << 5 | 0x10 | ((max[theta_bin] & 0xf) + 1);
  //  if(theta_bin >67 && theta_bin < 72)
  //    printf("bin%d we[0] = %d  we[1] = %d ae = %x ao = %x\n",theta_bin,we_RAM[0],we_RAM[1],ae,ao);
  return;
}

void dual_slice()
{
  int i, j, k, ra[2], we[2], we_RAM[2], ae, ao, ae_m[2], ao_m[2], theta_bin;
  long int r[2];
  for (i = 0; i < 2; i++)
    for(j = 0; j < 32; j++){
      theta_bin = i*64+j*2;
      //r - R_drift the first write for a hit
      r[0] = r_minusR[i][j];
      r[1] = r_minusR[i][j] + r_minusR[i][j+1];
      ra[0] = (r[0] & 0x3fc0) >> 6;
      ra[1] = (r[1] & 0x7f80) >> 7;
      if((r[0] & 0xc000) == 0 && OOR[i][j] == 0)
	we[0] = 1;
      else
	we[0] = 0;
      if((r[1] & 0x18000) == 0 && OOR[i][j] == 0 && OOR[i][j+1] == 0)
	we[1] = 1;
      else
	we[1] = 0;
      for( k = 0; k < 2; k++){
	ao = (0xff & ra[k]) >> 1;
	ae = (0xff & (ra[k]+1)) >> 1;
	we_RAM[1] = we[1];
	we_RAM[0] = we[0] && (!(0x40 & ao) || (0x40 & ae));
	slice_RAM(theta_bin+k,we_RAM, ae, ao);
	//	if(theta_bin > 64 && theta_bin < 80)
	//	  printf("theta_bin = 0x%x we0 %d we1 %d 0x%x 0x%x\n",theta_bin+k,we_RAM[0],we_RAM[1],ae,ao);
	ae_m[k] = ae;
	ao_m[k] = ao;
      }
      //r + R_drift, the second write for a hit
      r[0] = r_plusR[i][j];
      r[1] = r_plusR[i][j] + r_plusR[i][j+1];
      ra[0] = (r[0] & 0x3fc0) >> 6;
      ra[1] = (r[1] & 0x7f80) >> 7;
      if((r[0] & 0xc000) == 0 && OOR[i][j] == 0)
	we[0] = 1;
      else
	we[0] = 0;
      if((r[1] & 0x18000) == 0 && OOR[i][j] == 0 && OOR[i][j+1] == 0)
	we[1] = 1;
      else
	we[1] = 0;
      for( k = 0; k < 2; k++){
	ao = (0xff & ra[k]) >> 1;
	ae = (0xff & (ra[k]+1)) >> 1;
	if(ao == ao_m[k])
	  we_RAM[1] = 0;
	else
	  we_RAM[1] = we[k];
	if(ae == ae_m[k])
	  we_RAM[0] = 0;
	else 
	  we_RAM[0] = we[k] && (!(0x40 & ao) || (0x40 & ae));
	slice_RAM(theta_bin+k,we_RAM, ae, ao);
	//	if(theta_bin > 64 && theta_bin < 80)
	//	  printf("theta_bin = 0x%x we0 %d we1 %d 0x%x 0x%x\n",theta_bin+k,we_RAM[0],we_RAM[1],ae,ao);
      }
    }      
}

void dual_slice2()
{
  int i, j, k, ra[2], we[2], we_RAM[2], ae, ao, ae_m[2], ao_m[2], theta_bin;
  long int r[2];
  for (i = 0; i < 2; i++)
    for(j = 0; j < 32; j++){
      theta_bin = i*64+j*2;
      //r - R_drift the first write for a hit
      r[0] = r_minusR[i][j];
      r[1] = r_minusR[i][j] + r_minusR[i][j+1];
      ra[0] = (r[0] & 0x3fc0) >> 6;
      ra[1] = (r[1] & 0x7f80) >> 7;
      if((r[0] & 0xc000) == 0 && OOR[i][j] == 0)
	we[0] = 1;
      else
	we[0] = 0;
      if((r[1] & 0x18000) == 0 && OOR[i][j] == 0 && OOR[i][j+1] == 0)
	we[1] = 1;
      else
	we[1] = 0;
      for( k = 0; k < 2; k++){
	ao = (0xff & ra[k]) >> 1;
	ae = (0xff & ra[k]) >> 1;
	we_RAM[1] = we[1] && (0x1 & ra[k]);
	we_RAM[0] = we[0] && !(0x1 & ra[k]);
	slice_RAM(theta_bin+k,we_RAM, ae, ao);
	//	if(theta_bin > 64 && theta_bin < 80)
	//	  printf("theta_bin = 0x%x we0 %d we1 %d 0x%x 0x%x\n",theta_bin+k,we_RAM[0],we_RAM[1],ae,ao);
	ae_m[k] = ae;
	ao_m[k] = ao;
      }
      //r + R_drift, the second write for a hit
      r[0] = r_plusR[i][j];
      r[1] = r_plusR[i][j] + r_plusR[i][j+1];
      ra[0] = (r[0] & 0x3fc0) >> 6;
      ra[1] = (r[1] & 0x7f80) >> 7;
      if((r[0] & 0xc000) == 0 && OOR[i][j] == 0)
	we[0] = 1;
      else
	we[0] = 0;
      if((r[1] & 0x18000) == 0 && OOR[i][j] == 0 && OOR[i][j+1] == 0)
	we[1] = 1;
      else
	we[1] = 0;
      for( k = 0; k < 2; k++){
	ao = (0xff & ra[k]) >> 1;
	ae = (0xff & ra[k]) >> 1;
	if(ao == ao_m[k])
	  we_RAM[1] = 0;
	else
	  we_RAM[1] = we[1] && (0x1 & ra[k]);
	if(ae == ae_m[k])
	  we_RAM[0] = 0;
	else 
	  we_RAM[0] = we[0] && !(0x1 & ra[k]);
	slice_RAM(theta_bin+k,we_RAM, ae, ao);
	//	if(theta_bin > 64 && theta_bin < 80)
	//	  printf("theta_bin = 0x%x we0 %d we1 %d 0x%x 0x%x\n",theta_bin+k,we_RAM[0],we_RAM[1],ae,ao);
      }
    }      
}


void r_cal()
{
  int i, j;
  int64_t p[2][33];
  int32_t cos32, sin32;
  for (i = 0; i < 2; i++)
    for(j = 0; j < 33; j++){
      if(j < 16){
	cos32 = 0x3ffff & cosine[j%16+(j/32)*16][ROI_theta/2+i*32];
	sin32 = 0x3ffff & sine[j%16+(j/32)*16][ROI_theta/2+i*32];
      }
      else{
	cos32 = 0x3ffff & cosine[j%16+(j/32)*16][ROI_theta/2+i*32+16];
	sin32 = 0x3ffff & sine[j%16+(j/32)*16][ROI_theta/2+i*32+16];
      }
      if(0x20000 & cos32)
	cos32 -= 0x40000;
      if(0x20000 & sin32)
	sin32 -= 0x40000;
      //    if(j==0)      
      //      printf("i%d j%d cos = %05lx sin = %05lx\n",i,j,(long int)cos32,(long int)sin32);
      p[i][j] = ((cos32*z0 + sin32*y) >> 17) + R_drift + 64*128 - 32; // round down 0.25mm
      r_plusR[i][j] = 0xffff & p[i][j];
      r_minusR[i][j] = (0xffff & p[i][j]) - (R_drift << 1);
      //      if(i == 0 && j == 0)
      //	printf("z = %05x y = %05x\n", (int)z0, (int)y);
      //	printf("i%d j%d P = %lx\n",i,j,(long int)p[i][j]);
      if((p[i][j] & 0xf8000) != 0 && (p[i][j] & 0xf8000) != 0xf8000)
	OOR[i][j] = 1;
      else if((p[i][j] & 0xe000) == 0x8000 || (p[i][j] & 0xe000) == 0x6000)
	OOR[i][j] = 1;
      else
	OOR[i][j] = 0;
      /*      if(i==0)
	printf("rlow[%d] 0x%d%04x   0x%d%04x\n",j,OOR[i][j], 0xffff&r_plusR[i][j],OOR[i][j],0xffff & r_minusR[i][j]);
	else*/
      //      if(i==1 && j < 8)
      //	printf("rhigh[%d] 0x%d%04x   0x%d%04x\n",j,OOR[i][j], 0xffff&r_plusR[i][j],OOR[i][j],0xffff & r_minusR[i][j]);
      /*      printf("p[%d][%d] = %06lx ",i,j,p[i][j]);
      printf("r[%d][%d] = %05lx %05lx %01d ",i,j,0x1ffff & r_plusR[i][j], 0x1ffff & r_minusR[i][j], OOR[i][j]);
      if(j%2 == i)
      printf("\n");*/
    }
  //  printf("\n");
  return;
}


void new_hit(double a, double b, double c){
  z0 = (long int)(a*128.0+0.5) - ROI_z0;
  y = (long int)(b*128.0+0.5);
  R_drift = (int)(c*64.0+0.5);
  //  printf("r_drift = %x\n",R_drift);
  R_drift = R_drift*2;
  r_cal();
  if(strcmp(s,"s1") == 0 || strcmp(s,"s2") == 0){
    //    printf("call slice2\n");
    dual_slice2();}
  else{
    //    printf("call slice\n");
    dual_slice();}
  return;
}

void init_rom()
{
  FILE *f0, *f;
  int ln;
  char line[100],c9[9] = {" "};
  int i,j,k,l;
  int c;
  unsigned long int a,d[9];
  char *ptr;
  if((f0 = fopen("csc_xy_rom.coe","r")) == NULL){
    printf("csc_xy_rom.coe does not exist\n");
    exit(1);
  }
  //  f = fopen("output_file.txt","w");
  // loop over record in the file and read them in the array "line"
  ln = 0;
  while ( fgets(line, 100, f0) != NULL) {
    if(ln > 1)
      for(i = 0; i < 8; i++){
	a = strtol(line+i*6,&ptr,16);
	csc[(ln-2)*8+i] = a;
      }
    ln++;
  }
  fclose(f0);
  /*  for(i=0;i<4096;i++){
    fprintf(f,"%05d ",sine[i]);
    if((i % 8) == 7)
      fprintf(f,"\n");
  }
  fclose(f);*/
  if((f0 = fopen("cos_xy_rom.coe","r")) == NULL){
    printf("cos_xy_rom.coe does not exist\n");
    exit(1);
  }
  ln = 0;
  while ( fgets(line, 100, f0) != NULL) {
    if(ln > 1){
      strncpy(c9+3,line,5);
      a = strtol(c9+3,&ptr,16);
      cosine[16][ln-2] = 0x3ffff & a;
      for(i = 0; i < 9; i++){
	strncpy(c9,line+i*8+5,8);
	d[i] = strtol(c9,&ptr,16);
      }
      cosine[15][ln-2] = (0xffffc000 & d[0]) >> 14;
      cosine[14][ln-2] = (0x3fff & d[0]) << 4 | (0xf0000000 & d[1]) >> 28;
      cosine[13][ln-2] = (0xffffc00 & d[1]) >> 10;
      cosine[12][ln-2] = (0x3ff & d[1]) << 8 | (0xff000000 & d[2]) >> 24;
      cosine[11][ln-2] = (0xffffc0 & d[2]) >> 6;
      cosine[10][ln-2] = (0x3f & d[2]) << 12 | (0xfff00000 & d[3]) >> 20;
      cosine[9][ln-2] = (0xffffc & d[3]) >> 2;
      cosine[8][ln-2] = (0x3 & d[3]) << 16 | (0xffff0000 & d[4]) >> 16;
      cosine[7][ln-2] = (0xffff & d[4]) << 2 | (0xc0000000 & d[5]) >> 30;
      cosine[6][ln-2] = (0x3ffff000 & d[5]) >> 12;
      cosine[5][ln-2] = (0xfff & d[5]) << 6 | (0xfc000000 & d[6]) >> 26;
      cosine[4][ln-2] = (0x3ffff00 & d[6]) >> 8;
      cosine[3][ln-2] = (0xff & d[6]) << 10 | (0xffc00000 & d[7]) >> 22;
      cosine[2][ln-2] = (0x3ffff0 & d[7]) >> 4;
      cosine[1][ln-2] = (0xf & d[7]) << 14 | (0xfffc0000 & d[8]) >> 18;
      cosine[0][ln-2] = 0x3ffff & d[8];
    }
    ln++;
  }
  //  for(i = 0; i < 16; i++)
  //    printf("cos %06lx ",(long int)cosine[i][0]);
  //  printf("\n");
  fclose(f0);
  /*  for(i=0;i<4096;i++)
    for(j=0;j<16;j++){
      fprintf(f,"%06ld ",cosine[j][i]);
      if((j % 8) == 7)
	fprintf(f,"\n");
    }
    fclose(f);*/
  if((f0 = fopen("sin_xy_rom.coe","r")) == NULL){
    printf("sin_xy_rom.coe does not exist\n");
    exit(1);
  }
  ln = 0;
  while ( fgets(line, 100, f0) != NULL) {
    if(ln > 1){
      strncpy(c9+3,line,5);
      a = strtol(c9+3,&ptr,16);
      sine[16][ln-2] = 0x3ffff & a;
      for(i = 0; i < 9; i++){
	strncpy(c9,line+i*8+5,8);
	d[i] = strtol(c9,&ptr,16);
      }
      sine[15][ln-2] = (0xffffc000 & d[0]) >> 14;
      sine[14][ln-2] = (0x3fff & d[0]) << 4 | (0xf0000000 & d[1]) >> 28;
      sine[13][ln-2] = (0xffffc00 & d[1]) >> 10;
      sine[12][ln-2] = (0x3ff & d[1]) << 8 | (0xff000000 & d[2]) >> 24;
      sine[11][ln-2] = (0xffffc0 & d[2]) >> 6;
      sine[10][ln-2] = (0x3f & d[2]) << 12 | (0xfff00000 & d[3]) >> 20;
      sine[9][ln-2] = (0xffffc & d[3]) >> 2;
      sine[8][ln-2] = (0x3 & d[3]) << 16 | (0xffff0000 & d[4]) >> 16;
      sine[7][ln-2] = (0xffff & d[4]) << 2 | (0xc0000000 & d[5]) >> 30;
      sine[6][ln-2] = (0x3ffff000 & d[5]) >> 12;
      sine[5][ln-2] = (0xfff & d[5]) << 6 | (0xfc000000 & d[6]) >> 26;
      sine[4][ln-2] = (0x3ffff00 & d[6]) >> 8;
      sine[3][ln-2] = (0xff & d[6]) << 10 | (0xffc00000 & d[7]) >> 22;
      sine[2][ln-2] = (0x3ffff0 & d[7]) >> 4;
      sine[1][ln-2] = (0xf & d[7]) << 14 | (0xfffc0000 & d[8]) >> 18;
      sine[0][ln-2] = 0x3ffff & d[8];
    }
    ln++;
  }
  //  for(i = 0; i < 16; i++)
  //    printf("sin %06lx ",(long int)sine[i][0]);
  //  printf("\n");
  /*  for(i = 0; i < 8; i++)
    printf("%06lx ",cosineC[i]);
  printf("\n");
  for(i = 0; i < 8; i++)
    printf("%06lx ",cosineC[i+4088]);
    printf("\n");*/
  fclose(f0);
  /*  for(i=0;i<4096;i++){
    fprintf(f,"%06ld ",cosineC[i]);
    if((i % 8) == 7)
      fprintf(f,"\n");
      }
  fclose(f);*/
  return;
}
 
